
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Coaching_sessionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const coaching_sessions = await db.coaching_sessions.create(
            {
                id: data.id || undefined,
        
        coach_type: data.coach_type
        ||
        null
            ,
            
        session_status: data.session_status
        ||
        null
            ,
            
        topic: data.topic
        ||
        null
            ,
            
        private_notes: data.private_notes
        ||
        null
            ,
            
        started_at: data.started_at
        ||
        null
            ,
            
        ended_at: data.ended_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await coaching_sessions.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return coaching_sessions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const coaching_sessionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                coach_type: item.coach_type
            ||
            null
            ,
            
                session_status: item.session_status
            ||
            null
            ,
            
                topic: item.topic
            ||
            null
            ,
            
                private_notes: item.private_notes
            ||
            null
            ,
            
                started_at: item.started_at
            ||
            null
            ,
            
                ended_at: item.ended_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const coaching_sessions = await db.coaching_sessions.bulkCreate(coaching_sessionsData, { transaction });

        // For each item created, replace relation files
        

        return coaching_sessions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const coaching_sessions = await db.coaching_sessions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.coach_type !== undefined) updatePayload.coach_type = data.coach_type;
        
        
        if (data.session_status !== undefined) updatePayload.session_status = data.session_status;
        
        
        if (data.topic !== undefined) updatePayload.topic = data.topic;
        
        
        if (data.private_notes !== undefined) updatePayload.private_notes = data.private_notes;
        
        
        if (data.started_at !== undefined) updatePayload.started_at = data.started_at;
        
        
        if (data.ended_at !== undefined) updatePayload.ended_at = data.ended_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await coaching_sessions.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await coaching_sessions.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return coaching_sessions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const coaching_sessions = await db.coaching_sessions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of coaching_sessions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of coaching_sessions) {
                await record.destroy({transaction});
            }
        });


        return coaching_sessions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const coaching_sessions = await db.coaching_sessions.findByPk(id, options);

        await coaching_sessions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await coaching_sessions.destroy({
            transaction
        });

        return coaching_sessions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const coaching_sessions = await db.coaching_sessions.findOne(
            { where },
            { transaction },
        );

        if (!coaching_sessions) {
            return coaching_sessions;
        }

        const output = coaching_sessions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.messages_coaching_session = await coaching_sessions.getMessages_coaching_session({
            transaction
        });
        
        
        
        
        
        
        output.user = await coaching_sessions.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.topic) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'coaching_sessions',
                        'topic',
                        filter.topic,
                    ),
                };
            }
            
            if (filter.private_notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'coaching_sessions',
                        'private_notes',
                        filter.private_notes,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            started_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    ended_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.started_atRange) {
                const [start, end] = filter.started_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.ended_atRange) {
                const [start, end] = filter.ended_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    ended_at: {
                    ...where.ended_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    ended_at: {
                    ...where.ended_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.coach_type) {
                where = {
                    ...where,
                coach_type: filter.coach_type,
            };
            }
            
            if (filter.session_status) {
                where = {
                    ...where,
                session_status: filter.session_status,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.coaching_sessions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'coaching_sessions',
                        'topic',
                        query,
                    ),
                ],
            };
        }

        const records = await db.coaching_sessions.findAll({
            attributes: [ 'id', 'topic' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['topic', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.topic,
        }));
    }

    
};

